var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useEffect } from 'react';
import BarChart from './charts/BarChart.js';
import LineChart from './charts/LineChart.js';
import PieChart from './charts/PieChart.js';
import StackChart from './charts/StackChart.js';
export * from './types.js';
var ChartTitle = function (_a) {
    var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    var setup = _a.setup;
    if (((_c = (_b = setup.chart) === null || _b === void 0 ? void 0 : _b.title) === null || _c === void 0 ? void 0 : _c.show) !== true)
        return null;
    return (_jsx("div", { className: "s-dashboard__title", style: {
            color: ((_f = (_e = (_d = setup.chart) === null || _d === void 0 ? void 0 : _d.title) === null || _e === void 0 ? void 0 : _e.textStyle) === null || _f === void 0 ? void 0 : _f.color) || '#000',
            fontSize: ((_j = (_h = (_g = setup.chart) === null || _g === void 0 ? void 0 : _g.title) === null || _h === void 0 ? void 0 : _h.textStyle) === null || _j === void 0 ? void 0 : _j.fontSize) || 14,
        }, children: _jsx("p", { className: "s-dashboard__title--text", children: ((_m = (_l = (_k = setup.chart) === null || _k === void 0 ? void 0 : _k.title) === null || _l === void 0 ? void 0 : _l.text) === null || _m === void 0 ? void 0 : _m.trim()) || setup.title || '' }) }));
};
var ChartFooter = function (_a) {
    var _b, _c, _d;
    var setup = _a.setup;
    if (!((_b = setup.extraData) === null || _b === void 0 ? void 0 : _b.compare))
        return null;
    return (_jsxs("div", { className: "s-dashboard__footer", children: [((_c = setup.extraData.compare) === null || _c === void 0 ? void 0 : _c.status) && (_jsx("div", { className: "s-dashboard__footer--arrow", itemType: setup.extraData.compare.status })), ((_d = setup.extraData.compare) === null || _d === void 0 ? void 0 : _d.value) && (_jsx("div", { className: "s-dashboard__footer--text", children: setup.extraData.compare.value }))] }));
};
var ChartContainer = function (_a) {
    var setup = _a.setup, index = _a.index, configuration = _a.configuration;
    var getChartComponent = function () {
        var chartProps = {
            configuration: {
                fnGetChartDataAsync: configuration.fnGetChartDataAsync,
                setup: setup,
                loadingComponent: configuration.loadingComponentChartItem,
                errorComponent: configuration.errorComponentChartItem,
            },
        };
        switch (setup.type) {
            case 'vertical-bar-chart':
            case 'horizontal-bar-chart':
                return _jsx(BarChart, __assign({}, chartProps), index);
            case 'line-chart':
            case 'step-line-chart':
                return _jsx(LineChart, __assign({}, chartProps), index);
            case 'pie-chart':
                return _jsx(PieChart, __assign({}, chartProps), index);
            case 'stack-area-chart':
            case 'stack-bar-chart':
                return _jsx(StackChart, __assign({}, chartProps), index);
            default:
                return _jsxs("div", { children: ["Unknown chart type: ", JSON.stringify(setup)] }, index);
        }
    };
    return (_jsxs("div", { className: "s-dasboard__item", style: {
            gridColumn: "".concat(Number(setup.x) + 1, " / span ").concat(setup.width),
            gridRow: "".concat(Number(setup.y) + 1, " / span ").concat(setup.height),
        }, children: [_jsx(ChartTitle, { setup: setup }), getChartComponent(), _jsx(ChartFooter, { setup: setup })] }, index));
};
var SDashboard = function (props) {
    var _a = React.useState('loading'), status = _a[0], setStatus = _a[1];
    var _b = React.useState([]), dashboardItems = _b[0], setDashboardItems = _b[1];
    var getItemsAsync = function () { return __awaiter(void 0, void 0, void 0, function () {
        var result, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    return [4, props.configuration.fnGetItemsAsync({
                            dashboardCode: props.dashboardCode,
                        })];
                case 1:
                    result = _b.sent();
                    setStatus('loaded');
                    setDashboardItems(result);
                    return [3, 3];
                case 2:
                    _a = _b.sent();
                    setStatus('error');
                    setDashboardItems([]);
                    return [3, 3];
                case 3: return [2];
            }
        });
    }); };
    useEffect(function () {
        getItemsAsync();
    }, []);
    if (status === 'loading') {
        if (props.configuration.loadingComponent)
            return props.configuration.loadingComponent;
        return (_jsx("div", { className: "s-dashboard s-dashboard-loading", children: _jsx("h1", { children: "Loading..." }) }));
    }
    if (status === 'error') {
        if (props.configuration.errorComponent)
            return props.configuration.errorComponent;
        return (_jsx("div", { className: "s-dashboard s-dashboard-error", children: _jsx("h1", { children: "Error" }) }));
    }
    return (_jsxs("div", { className: "s-dashboard s-dashboard-loaded", style: {
            display: 'grid',
            gridTemplateColumns: "repeat(".concat(props.grid_column || 2, ", 1fr)"),
            backgroundColor: props.background || 'transparent',
            gap: (props.gap || 16) + 'px',
        }, children: [props.title && _jsx("h1", { className: "s-dashboard-title", children: props.title }), dashboardItems.map(function (item, index) { return (_jsx(ChartContainer, { setup: item.setup, index: index, configuration: props.configuration }, index)); })] }));
};
export default SDashboard;
