export type SDashboardItemSetup_Chart_X_axis = {
    field?: string | null;
    min?: number | null;
    max?: number | null;
    axisLabel?: SDashboardItemSetup_Chart_X_axis_AxisLabel | null;
    splitLine?: SDashboardItemSetup_Chart_X_axis_SplitLine | null;
};
export type SDashboardItemSetup_Chart_X_axis_SplitLine = {
    lineStyle?: SDashboardItemSetup_Chart_X_axis_SplitLine_LineStyle | null;
};
export type SDashboardItemSetup_Chart_X_axis_SplitLine_LineStyle = {
    color?: string | null;
    type?: string | null;
    width?: number | null;
};
export type SDashboardItemSetup_Chart_X_axis_AxisLabel = {
    rotate?: number | null;
};
export type SDashboardItemSetup_Chart_Y_axis = {
    field?: string | null;
    min?: number | null;
    max?: number | null;
    axisLabel?: SDashboardItemSetup_Chart_Y_axis_AxisLabel | null;
    splitLine?: SDashboardItemSetup_Chart_Y_axis_SplitLine | null;
};
export type SDashboardItemSetup_Chart_Y_axis_AxisLabel = {
    rotate?: number | null;
};
export type SDashboardItemSetup_Chart_Y_axis_SplitLine = {
    lineStyle?: SDashboardItemSetup_Chart_Y_axis_SplitLine_LineStyle | null;
};
export type SDashboardItemSetup_Chart_Y_axis_SplitLine_LineStyle = {
    color?: string | null;
    type?: string | null;
    width?: number | null;
};
export type SDashboardItemSetup_Chart_Seri = {
    field?: string | null;
};
export type SDashboardItemSetup_Chart_Item_styles = {
    condition?: SDashboardItemSetup_Chart_Item_styles_Condition | null;
    style?: SDashboardItemSetup_Chart_Item_styles_Style | null;
};
export type SDashboardItemSetup_Chart_Item_styles_Condition = {
    index?: number | null;
    name?: string | null;
    regex?: string | null;
    gt?: number | null;
    gte?: number | null;
    lt?: number | null;
    lte?: number | null;
};
export type SDashboardItemSetup_Chart_Item_styles_Style = {
    bg_color?: string | null;
    bg_to_color?: string | null;
    line_color?: string | null;
    border_radius?: Array<number | null | undefined> | null;
    smooth?: boolean | null;
    radar_max?: number | null;
};
export type SDashboardItemSetup_Chart_Legend_Align = {
    horizontal?: string | null;
    vertical?: string | null;
};
export type SDashboardItemSetup_Chart_Legend = {
    show?: boolean | null;
    orient?: string | null;
    align?: string | null;
    left?: string | null;
    top?: string | null;
    right?: string | null;
    bottom?: string | null;
};
export type SDashboardItemSetup_Chart_Tooltip_TextStyle = {
    fontSize?: number | null;
    color?: string | null;
};
export type SDashboardItemSetup_Chart_Title_TextStyle = {
    fontSize?: number | null;
    color?: string | null;
};
export type SDashboardItemSetup_Chart_Tooltip = {
    show?: boolean | null;
    trigger?: string | undefined;
    backgroundColor?: string | null;
    borderRadius?: number | null;
    textStyle?: SDashboardItemSetup_Chart_Tooltip_TextStyle | null;
};
export interface SDashboardItemSetup_Chart_Title {
    show?: boolean | null;
    text?: string | null;
    textStyle?: SDashboardItemSetup_Chart_Title_TextStyle | null;
}
export type SDashboardItemSetup_Chart = {
    title?: SDashboardItemSetup_Chart_Title | null;
    legend?: SDashboardItemSetup_Chart_Legend | null;
    tooltip?: SDashboardItemSetup_Chart_Tooltip | null;
    x_axis?: SDashboardItemSetup_Chart_X_axis | null;
    y_axis?: SDashboardItemSetup_Chart_Y_axis | null;
    seri?: SDashboardItemSetup_Chart_Seri | null;
    item_styles?: Array<SDashboardItemSetup_Chart_Item_styles | null | undefined> | null;
    chart_link?: string | null;
};
export type SDashboardItemSetup_type = 'vertical-bar-chart' | 'horizontal-bar-chart' | 'line-chart' | 'pie-chart' | 'stack-area-chart' | 'stack-bar-chart' | 'step-line-chart';
export type SDashboardItemSetup = {
    id: string;
    type: SDashboardItemSetup_type | string;
    title?: string;
    x: number;
    y: number;
    width: number;
    height: number;
    chart?: SDashboardItemSetup_Chart | null;
    extraData?: {
        compare?: {
            title?: string;
            status?: 'up' | 'down';
            value?: string;
        };
    };
};
export type SDashboardItemSetting = {
    loadingComponent?: React.JSX.Element;
    loadingComponentItem?: React.JSX.Element;
    errorComponent?: React.JSX.Element;
    setup: SDashboardItemSetup;
};
export type SDashboardItemConfiguration = SDashboardItemSetting & {
    fnGetChartDataAsync: (arg: GetChartDataParameters) => Promise<Array<Record<string, number | string>>>;
};
export type GetItemsParameters = {
    dashboardCode: string;
    limit?: number;
    offset?: number;
};
export type GetChartDataParameters = {
    id: string;
};
export type SDashboardConfiguration = {
    fnGetItemsAsync: (arg: GetItemsParameters) => Promise<Array<SDashboardItemSetting>>;
    fnGetChartDataAsync: (arg: GetChartDataParameters) => Promise<Array<Record<string, number | string>>>;
    loadingComponent?: React.JSX.Element;
    loadingComponentChartItem?: React.JSX.Element;
    errorComponent?: React.JSX.Element;
    errorComponentChartItem?: React.JSX.Element;
};
export type SDashboardProps = {
    dashboardCode: string;
    enabled: boolean;
    title?: string;
    grid_column?: number;
    gap?: string | number;
    background?: string;
    configuration: SDashboardConfiguration;
};
export type SDashboardItemProps = {
    configuration: SDashboardItemConfiguration;
};
